"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isObjectReference = exports.isArrayEnd = exports.isArrayReference = exports.find = void 0;
const util_1 = require("./util");
const { isArray } = Array;
exports.find = (val, path, skipLast = 0) => {
    if (util_1.isRoot(path))
        return { val };
    let obj;
    let key;
    const last = path.length - 1 - skipLast;
    for (let i = 0; i <= last; i++) {
        const component = path[i];
        obj = val;
        key = component;
        if (isArray(obj)) {
            if (key === '-' && i === path.length - 1)
                key = obj.length;
            else {
                if (!util_1.isValidIndex(key))
                    throw new Error('INVALID_INDEX');
                key = Number(key);
                if (key < 0)
                    throw new Error('INVALID_INDEX');
            }
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else if (typeof obj === 'object' && !!obj) {
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else
            throw new Error('NOT_FOUND');
    }
    const ref = { val, obj, key };
    return ref;
};
exports.isArrayReference = (ref) => isArray(ref.obj) && typeof ref.key === 'number';
exports.isArrayEnd = (ref) => ref.obj.length === ref.key;
exports.isObjectReference = (ref) => typeof ref.obj === 'object' && typeof ref.key === 'string';
