import { Message, MessageError, MessageData, MessageComplete } from './types';
import { Observable } from 'rxjs';
export interface JsonRxClientParams {
    send: (message: Message) => void;
}
export declare class JsonRxClient {
    private readonly send;
    private cnt;
    private readonly observers;
    constructor({ send }: JsonRxClientParams);
    private sendSubscribe;
    private sendUnsubscribe;
    private onData;
    private onComplete;
    private onError;
    onMessage(message: MessageData | MessageComplete | MessageError): void;
    call(method: string, payload: unknown): Observable<unknown>;
    notify(name: string, payload?: unknown): void;
}
