import { deepClone } from './util';
import { operationToOp } from './op';
export function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = deepClone(doc);
    return op.apply(doc);
}
export function applyOps(doc, ops, mutate) {
    if (!Array.isArray(ops))
        throw new Error('SEQUENCE_NOT_AN_ARRAY');
    if (!mutate)
        doc = deepClone(doc);
    const res = [];
    for (const op of ops) {
        const opResult = op.apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc, res };
}
export function applyPatch(doc, patch, mutate) {
    const result = applyOps(doc, patch.map(operationToOp), mutate);
    return result;
}
