import { isRoot, isValidIndex, hasOwnProperty } from './util';
const { isArray } = Array;
export const find = (val, path, skipLast = 0) => {
    if (isRoot(path))
        return { val };
    let obj;
    let key;
    const last = path.length - 1 - skipLast;
    for (let i = 0; i <= last; i++) {
        const component = path[i];
        obj = val;
        key = component;
        if (isArray(obj)) {
            if (key === '-' && i === path.length - 1)
                key = obj.length;
            else {
                if (!isValidIndex(key))
                    throw new Error('INVALID_INDEX');
                key = Number(key);
                if (key < 0)
                    throw new Error('INVALID_INDEX');
            }
            val = hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else if (typeof obj === 'object' && !!obj) {
            val = hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else
            throw new Error('NOT_FOUND');
    }
    const ref = { val, obj, key };
    return ref;
};
export const isArrayReference = (ref) => isArray(ref.obj) && typeof ref.key === 'number';
export const isArrayEnd = (ref) => ref.obj.length === ref.key;
export const isObjectReference = (ref) => typeof ref.obj === 'object' && typeof ref.key === 'string';
