"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validatePath = exports.validateJsonPointer = void 0;
var tslib_1 = require("tslib");
exports.validateJsonPointer = function (pointer) {
    if (typeof pointer === 'string') {
        if (pointer) {
            if (pointer[0] !== '/')
                throw new Error('JSON pointer must start with forward slash.');
            if (pointer.length > 1024)
                throw new Error('Pointer too long.');
        }
    }
    else
        exports.validatePath(pointer);
};
var isArray = Array.isArray;
exports.validatePath = function (path) {
    var e_1, _a;
    if (!isArray(path))
        throw new Error('Invalid path.');
    if (path.length > 256)
        throw new Error('Path too long.');
    try {
        for (var path_1 = tslib_1.__values(path), path_1_1 = path_1.next(); !path_1_1.done; path_1_1 = path_1.next()) {
            var step = path_1_1.value;
            switch (typeof step) {
                case 'string':
                case 'number':
                    continue;
                default:
                    throw new Error('Invalid path step.');
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (path_1_1 && !path_1_1.done && (_a = path_1.return)) _a.call(path_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
};
