import { Message } from './types';
import { Observable } from 'rxjs';
export interface JsonRxServerParams {
    send: (message: Message) => void;
    call: (name: string, payload?: unknown) => Promise<unknown> | Observable<unknown>;
    notify: (name: string, payload?: unknown) => void;
    maxActiveSubscriptions?: number;
}
export declare class JsonRxServer {
    private readonly send;
    private call;
    private notify;
    private readonly active;
    private readonly maxActiveSubscriptions;
    constructor({ send, call, notify, maxActiveSubscriptions }: JsonRxServerParams);
    private sendError;
    private onSubscribe;
    private onUnsubscribe;
    private onNotification;
    onMessage(message: Message): void;
}
